#ifdef __GNUG__
#include <exception>
#include <typeinfo>
#else 
#include <exception.h>
#endif

#include <iostream.h>
#include <stdlib.h>

class X {
	char* name;
public:
	X(char *n): name(n){cout<<"X::X() for "<<name<<"\n";}
	~X(){cout<<"X::~X() for "<<name<<"\n";}
};

class Arithmetic_Exception {
public:
	virtual ~Arithmetic_Exception(){}
};

class Division_by_Zero: public Arithmetic_Exception
{
	const char * f;
	const int l;
public:
	Division_by_Zero(const char* file, const int line)
			:f(file),l(line){cout<<"ctor\n";}
	~Division_by_Zero(){cout<<"dtor\n";}
	friend ostream& operator<<(ostream& o, Division_by_Zero& d) {
	return o<<"Division durch Null: FILE: "<<d.f<<" LINE: "<<d.l<<endl;
	}
};

double f(double i) throw (Division_by_Zero)
{
	X x1("x1");
	X *p = new X ("dynamic");
	if (i==0.0) throw Division_by_Zero(__FILE__, __LINE__);
	X x2("x2");
	delete p;
	return 1/i;
}

void (*old_terminate)()=abort; 

void new_terminate()
{
        cout<<"Termination due to unhandled exception\n"<<flush;
        old_terminate();
}


int main()
{

        cout<<"setting new termination handler\n";
	set_terminate(old_terminate);
        old_terminate=set_terminate(new_terminate);

try {
	cout<<"outer try>>>>>>>\n";
	try
	{
		cout<<"inner try>>>>>>>>>\n";

		X x3("x3");

		f(1);
		f(0);
		cout<<"<<<<<<<<<inner try\n";
	}
	// at least one handler must follow !!

	catch (Division_by_Zero& d)
	{
		cout<< d;
		/*re*/ throw; 
	}

	catch (Arithmetic_Exception& d)
	{
		cout<< "any arithmetic exception\n";
	}	

	cout<<"<<<<<<<outer try\n";

}


catch (Arithmetic_Exception& d)
{
	cout<< "any arithmetic exception\n";
	/*re*/ throw /*once more without handler*/;
}


}
/*
setting new termination handler
outer try>>>>>>>
inner try>>>>>>>>>
X::X() for x3
X::X() for x1
X::X() for dynamic
X::X() for x2
X::~X() for dynamic
X::~X() for x2
X::~X() for x1
X::X() for x1
X::X() for dynamic
ctor
X::~X() for x1
X::~X() for x3
Division durch Null: FILE: e.C LINE: 40
any arithmetic exception
dtor 				// fehlt bei g++ 2.7.2
*/

