#include "link.h"

IDENTIFY(Linkage);
IDENTIFY(Link);
IDENTIFY(Head);

Linkage::Linkage(): l_pred(0), l_suc(0) {}

Link::Link() {}

Link::Link(class Head& h)
{
       into(h);
}

void Link::into(Head& h)
{
	l_pred=h.l_suc;
	if (h.l_suc==&h) h.l_pred=this;
	   else    h.l_suc->l_suc=this;
	h.l_suc=this;
	l_suc=&h;
}

void Link::out()
{
	l_pred->l_suc=l_suc;
	l_suc->l_pred=l_pred;
	l_suc=l_pred=0;
}

Link* Link::pred()
{
	if (l_pred IN(Link)) return (Link*)l_pred;
	return 0;
}

Link* Link::suc()
{
	if (l_suc IN(Link)) return (Link*)l_suc;
	return 0;
}

Head::Head()
{
	l_suc=l_pred=this;
};

int Head::length()
{
	int l=0;
	for (Linkage *p=l_suc; p!=this; l++, p=p->l_suc);
	return l;
}

Link* Head::first()
{
	if (l_pred IN(Link)) return (Link*)l_pred;
	return 0;
}
Link* Head::last()
{
	if (l_suc IN(Link)) return (Link*)l_suc;
	return 0;
}

