#ifndef OBJECT_H
#define OBJECT_H 

#include <stdio.h>

#define IS(class) ->type()==&class::id
#define IN(class) ->subtype(&class::id)
#define BASE(base) public: virtual int* type(){return &id;} \
					static int id;\
					virtual int subtype(int *s)\
					{return (s==&id) || base::subtype(s);}
#define BASE2(base1, base2) public: virtual int* type(){return &id;} \
					static int id;\
					virtual int subtype(int *s)\
					{return (s==&id) || \
				            base1::subtype(s) || \
				            base2::subtype(s); \
				    }

#define IDENTIFY(class) int class::id=0;
#define GUARD(class, pointer) ((p IN (class))?(class*)p:\
				(class*)guard_error(#pointer, #class, __FILE__, __LINE__))

struct Nothing { virtual int subtype(int*){return 0;}};

class Object: public Nothing {
	BASE(Nothing);
};

void* guard_error (const char*, const char*, const char*, const int);

#endif
