#include <malloc.h>
#include <stdio.h>

#define TRACE
#define size_t unsigned long int
const N=128;

struct mem{ mem* next;};

static unsigned long mem_size = 0;
void* operator new (size_t size)
{
//	BEWARE OF:
//	              cout<<"new called\n";
//	because construction of static object cout
//	calls new itself !!!!!!!!
	void* p=calloc(size, 1);
	if (!p) fprintf(stderr, "\nHeap Overflow\n");
	int align=(int)p;
	align+=align%2;
	int rsize=*((int*)align-2);
#ifdef TRACE
	printf("::new called, ordering %d bytes\n", size);
	printf("\t\t got %d bytes\n", rsize);
	printf("\tallocated so far %d bytes\n", mem_size+=rsize);
#endif	
	return p;
}

void operator delete (void* p)
{
	int align=(int)p;
	align+=align%2;
	int size=*((int*)align-2);
#ifdef TRACE
	printf("::delete called for %d bytes\n", size);
	printf("\tallocated now %d bytes\n", mem_size-=size);
#endif
	if (p) free((char*)p);
}

class small {
	static small* free;
	int i, j, k; // and possibly more
	static int count;

public:
	void* operator new (size_t s)	{
#ifdef TRACE
	printf("small::new called, ordering %d bytes\n", s);
#endif


		small* p;
		if (!free)
		{
			free=(small*)::new char [s*N];
// BEWARE OF:    ...........= ::new small[N];
//              would call N 'small' constructors !!!

			for (p=free; p<free+N-1; p++)
				((mem*)p)->next=(mem*)p+1;
			((mem*)(free+N-1))->next=0;
		}
		p=free;
		free=(small*)((mem*)free)->next;
		return p;
	}
	
	void* operator new[] (size_t s)	{
#ifdef TRACE
	printf("small::new[] called, ordering %d bytes\n", s);
#endif


		small* p;
		p=(small*)::new char [s];
// BEWARE OF:    ...........= ::new small[N];
//              would call N 'small' constructors !!!
		return p;
	}

	void operator delete (void* p) // should be small*
	{
#ifdef TRACE
	printf("small::delete called\n");
#endif
		if(p)
		{
			((mem*)p)->next=(mem*)free;
			free=(small*)p;
		}
	}

	void operator delete[] (void* p) // should be small*
	{
#ifdef TRACE
	printf("small::delete[] called\n");
#endif
		if(p)
			::free(p);
	}

	small(){count++;}
	~small(){--count;};
	static void n(){printf("there are %d small-objects now\n", count);}
};

small* small::free=0;
int    small::count=0;

class a_little_bigger: public small { int l; };

main()
{
//	printf("vvvvvvvvvvvvvvvvvvvvvvv\n");
/*
	small::n();
	small* s=new small;
	small::n();
	delete s;
	small::n();
	printf ("----------------------\n");
	small* f=new small[100];
	small::n();
	delete [] f;
	small::n();

	a_little_bigger *b = new a_little_bigger;
	small::n();
// this object is allocated wrong with size sizeof(small) !!!
	delete b;
	small::n();

	int* p=new int;
	delete p;
*/
//	printf("^^^^^^^^^^^^^^^^^^^^^^\n");

}

/*
there are 0 small-objects now
small::new called, ordering 12 bytes
::new called, ordering 1536 bytes
there are 1 small-objects now
small::delete called
there are 0 small-objects now
----------------------
::new called, ordering 1200 bytes
there are 100 small-objects now
::delete called
there are 0 small-objects now
small::new called, ordering 16 bytes
there are 1 small-objects now
small::delete called
there are 0 small-objects now
*/




