#include <iostream>

class A{
public:
	A(int i): n(i) {
		cout<<"constructing an A with n="<<n<<"\n";
	}
	~A() {
		cout<<"destructing an A with n="<<n<<"\n";
	}
	int  n;
	void f() {cout<<"f() for A("<<n<<")\n";}
};

class Aptr {
	A* ptr;
public:
	Aptr (A* p=0): ptr(p) {}
	~Aptr () { delete ptr; }
	Aptr (const Aptr&);		// not implemented
	Aptr& operator=(const Aptr&); 	// not implemented

	A* operator->() {return ptr;}
};


int main()
{
	A* a = new A(1111);
	Aptr p = new A(2222);

//	Aptr another=p; 	// linker error
	Aptr yetanother;

//	yetanother=p;		// linker error

	cout<<a->n<<endl;
	a->f();

	cout<<p->n<<endl;
	p->f();
}

/*
constructing an A with n=1111
constructing an A with n=2222
1111
f() for A(1111)
2222
f() for A(2222)
destructing an A with n=2222
*/
	
