#include <iostream.h>
 
class Point
{
protected: 
	int x, y;
public:
	Point (int px, int py): x(px), y(py) {};
	int get_x() { return x; };
	int get_y() { return y; };
};

Point zero(0,0);

class Shape  
{
protected:
	Point origin;
public:
	Shape(Point o=zero): origin(o) {};
	void move (Point new_orig);
	virtual void draw();
	virtual void erase();
};

void Shape::move (Point new_orig)
{
	erase();
	origin=new_orig;
	draw();
}

void Shape::erase()
{
	cout << " cannot erase an abstract shape\n";
}

void Shape::draw()
{
	cout << " cannot draw an abstract shape\n";
}


class Box: public Shape
{
	Point dxdy;
public:
	Box (Point p1, Point p2): Shape(p1), dxdy(p2) {}
	void erase() {cout << "erasing a box\n";}
	void draw() {cout << "drawing a box\n";}
};


class Circle: public Shape
{
	int radius;
public:
	Circle (Point m, int rad): Shape(m), radius(rad) {}
	void erase() {cout << "erasing a circle\n";}
	void draw() {cout << "drawing a circle\n";}
};

typedef int Color;

class Colored_Circle: public Circle
{
	Color col;
public:
	Colored_Circle (Point m, int rad, Color c ): Circle(m, rad),
                                                     col(c) {}
	void erase() {cout << "erasing a colored Circle\n";}
	void draw() {cout << "drawing a colored Circle\n";}

};

void main()
{
	Box b (Point (0, 0), Point (10, 10));
	Circle c (Point (10, 10), 20);
	Colored_Circle cc (Point (20, 20), 30, 1);

	b.draw();
	c.draw();
	cc.draw();

	b.move(Point(10, 10));
	c.move(zero);
	cc.move(Point(-10, -10));
}

