	////////////////////sample/stl/mapfind.cc//////////////////////////
	#include <map>
	#include <iostream>
	#include <string>
	#include <algorithm>
	#include <time.h> // itgendwann einmal ctime

	inline bool test12345(map<int,int>::value_type elem) {
		return elem.first==12345;
	}

	main() {
		map <int, int> m;
		long start, elapsed;
		int f;
		cout<<"Generating 200.000 nodes: "<<flush;
		start=clock();
		for(int i=0; i<100000; ++i) m[rand()]=rand();
		m[12345]=12345;
		for(int i=1; i<100000; ++i) m[rand()]=rand();
		elapsed=clock()-start;
		cout<<"in "<<elapsed/1000000.0<<" Sekunden\n";
		cout<<m.size()<<" Elemente in der Map"<<endl;

		cout<<"m.find(...): "<<flush;
		start=clock();
		for (int i=1; i<1000; ++i) m.find(12345);
		f=m.find(12345)->second;
		elapsed=clock()-start;
		cout<<"found "<<f<<" in "<<elapsed/1000000.0<<" Sekunden\n";

		cout<<"find (...): "<<flush;
		start=clock();
		for (int i=1; i<1000; ++i) find_if(m.begin(), m.end(), test12345);
		f=find_if(m.begin(), m.end(), test12345)->second;
		elapsed=clock()-start;
		cout<<"found "<<f<<" in "<<elapsed/1000000.0<<" Sekunden\n";
	}
	/*
	Generating 200.000 nodes: in 7.62 Sekunden
	32697 Elemente in der Map
	m.find(...): found 19134 in 0.03 Sekunden
	find (...): found 19134 in 30.03 Sekunden
	!!! FAKTOR ~1000 !!!
	*/
