	////////////////////sample/stl/multimapfind.cc//////////////////////
	#include <map>
	#include <iostream>
	#include <string>
	#include <algorithm>
	#include <time.h>

	using namespace std;

	typedef multimap<int,int>::value_type VT;

	inline bool test12345(VT elem) {
		return elem.first==12345;
	}

	main()		{
		multimap <int, int> m;
		long start, elapsed;
		int f;

		cout<<"Generating 200.000 nodes: "<<flush;
		start=clock();
		for(int i=0; i<100000; ++i) m.insert(VT(rand(),rand()));
		m.insert(VT(12345,12345));
		for(int i=1; i<100000; ++i) m.insert(VT(rand(),rand()));
		elapsed=clock()-start;
		cout<<"in "<<elapsed/1000000.0<<" Sekunden\n";
		cout<<m.size()<<" Elemente in der Multimap"<<endl;

		cout<<"m.find(...): "<<flush;
		start=clock();
		for (int i=1; i<1000; ++i) m.find(12345);
		f=m.find(12345)->second;
		elapsed=clock()-start;
		cout<<"found "<<f<<" in "<<elapsed/1000000.0<<" Sekunden\n";

		cout<<"find (...): "<<flush;
		start=clock();
			for (int i=1; i<1000; ++i) 
				find_if(m.begin(), m.end(), test12345);
		f=find_if(m.begin(), m.end(), test12345)->second;
		elapsed=clock()-start;
		cout<<"found "<<f<<" in "<<elapsed/1000000.0<<" Sekunden\n";
	}
	/*
	Generating 200.000 nodes: in 10.48 Sekunden
	200000 Elemente in der Multimap
	m.find(...): found 30080 in 0.03 Sekunden
	find (...): found 30080 in 242.99 Sekunden
	!!! FAKTOR ~8000 !!!
	*/
