#ifdef __GNUG__
#  pragma implementation
#endif

#include "Stack.h"
#include <stdlib.h>

//---- Stack ---------------------------------------------------------

Stack::Stack(int dim): max(dim), top(0), data(new int[max]) { }

Stack::Stack(const Stack & other)
	: max(other.max), top(other.top), data(new int[max])
{
	for (int i=0; i<top; i++)
		data[i]=other.data[i];
}
	
Stack::~Stack()
{
	delete [] data;
}

void Stack::push (int i)
{
	if (!full()) data[top++]=i;
	else exit(-1);
}

int Stack::pop ()
{
	if (!empty()) return data[--top];
	else exit(-1);
}

int Stack::full()
{
	return top==max;
}

int Stack::empty()
{
	return top==0;
}

