#include <map>
#include <string>
#include <algo.h>

template <class S, class T>
void print (pair<S, T> p)
{ cout << p.first << ": " <<p.second << endl; }

template <class Pair>
class Printer {
public:
	void operator ()(Pair p)
	{
		::print(p);
	}
};

//typedef char* string;

int main()
{
	typedef map <string, double, less<string> > Table;
	typedef pair<const string, double> P;

	typedef map <double, string, less<double> > RevTable;
	typedef pair<const double, string> Q;

	Printer<P> printer;
	Printer<Q> Revprinter;

	Table m;

	m["pi"]=3.141;
	m["zehn"]=10;
	m["Wurzel aus 2"]=1.41;
	
	for(Table::iterator pos = m.begin(); pos != m.end(); ++pos)
		print(*pos);

	for_each(m.begin(), m.end(), printer);

//	RevTable r (m.begin(), m.end()); // not with g++ 2.7.2.

	RevTable r;
	
	for (Table::iterator pos = m.begin(); pos != m.end(); ++pos)
		r[(*pos).second]=(*pos).first;

	for(RevTable::iterator pos = r.begin(); pos != r.end(); ++pos)
		print(*pos);

	for_each(r.begin(), r.end(), Revprinter);

	
}
